'
' COOKIE DELIVERY  ver 1.02
'  Copyright (c) Jaws-V soft, 1996-1997.
'
DEFINT A-Z

DECLARE SUB ADJUSTEYE (P)
DECLARE SUB CALSTICK ()
DECLARE SUB DELAY (P)
DECLARE SUB DEMO (N, JSVSCORE&)
DECLARE SUB DEMOFX ()
DECLARE SUB DRAWBACKGROUND (SCORE&, HISCORE&, JSVSCORE&, JSVNUM&)
DECLARE SUB DRAWNEWFONT (X, Y, C1, C2, S, S$)
DECLARE SUB DRAWPLATE (X, Y, P, P2)
DECLARE SUB ERASEBOX ()
DECLARE SUB FADE (P)
DECLARE SUB GAME (RESULT, SCORE&, HISCORE&, JSVSCORE&, JSVNUM&, MAXOBJ)
DECLARE SUB GLOW (N)
DECLARE SUB INITGRAPHIC ()
DECLARE SUB INITMAINVARIABLE ()
DECLARE SUB INITSTICK ()
DECLARE SUB LOADLEVEL (P, SCORE&, HISCORE&, JSVSCORE&, JSVNUM&, MAXOBJ)
DECLARE SUB LOADSCR (S$, P)
DECLARE SUB LOADSCREEN (S$, P)
DECLARE SUB LOGO ()
DECLARE SUB MAIN (HISCORE&)
DECLARE SUB MENU (N)
DECLARE SUB NEWCOLOR ()
DECLARE SUB OUTPUTAUXPAGE ()
DECLARE SUB OUTPUTBIGNUMBER (X, Y, N)
DECLARE SUB OUTPUTLEVEL (N)
DECLARE SUB SCROLLTEXT ()
DECLARE SUB SUBDEMO (P)
DECLARE SUB SUBMENU (N, RESULT)
DECLARE SUB TALK (MSG$, MOUTH$, LINENUM)
DECLARE SUB TITLE ()
DECLARE SUB UPDATEBLINK (N, P)
DECLARE SUB UPDATECOOKIE (X, Y, P, P2)
DECLARE SUB UPDATECURSOR (X, Y, N)
DECLARE SUB UPDATEDEMO (X, Y, P, P1)
DECLARE SUB UPDATEDOOR (N, P)
DECLARE SUB UPDATEEYE (N, P)
DECLARE SUB UPDATEFLAME (X, Y, N, P)
DECLARE SUB UPDATEMOUTH (N, P)
DECLARE SUB UPDATEOBJECT (X, Y, P, P2)
DECLARE SUB UPDATEOUCH (X, Y, P)
DECLARE SUB UPDATESCORE (SC&, HI, P)
DECLARE SUB UPDATESUBMENU (P, N)
DECLARE SUB UPDATESUN (X, Y, N, P)
DECLARE SUB VIEWER ()
DECLARE SUB VIEWERSCROLL (OBJP, OBJPTN, CELPTN, DIR)

DECLARE FUNCTION BUTTON (P)
DECLARE FUNCTION JOYPAD ()
DECLARE FUNCTION NUM2STR$ (N&, L)

CONST FALSE = 0
CONST TRUE = NOT FALSE

CONST DRIVE$ = "C:"
CONST DATAPATH$ = ""
CONST GRAPHICPATH$ = ""
CONST LEVELNAME$ = "LEVEL.LVL"

CONST VISPAGE = 0
CONST TITLEPAGE = 4
CONST DEMOPAGE = 5
CONST LOGOPAGE = 6
CONST BACKGROUNDPAGE = 6
CONST AUXPAGE = 7

CONST COLOR2BLACK = 0
CONST BLACK2COLOR = 1

CONST MAXJSV = 4

TYPE JOYPADINFO
  STICKMINY  AS INTEGER
  STICKMAXY  AS INTEGER
  STICKMINX  AS INTEGER
  STICKMAXX  AS INTEGER
  STICKFOUND AS INTEGER
  CALIBRATED AS INTEGER
  STICKON    AS INTEGER
END TYPE

TYPE GAMEINFO
  DEBUG  AS INTEGER
  MUTEKI AS INTEGER
  BEAT   AS INTEGER
END TYPE

COMMON SHARED GAMEDATA AS GAMEINFO
COMMON SHARED JOY AS JOYPADINFO

REDIM SHARED FMVDATA(1587)
REDIM SHARED FMVMASK(441)

REDIM SHARED LEVELARRAY(38, 3)
REDIM SHARED MAPDATA(38, 3)
REDIM SHARED LINKDATA(38, 3)
REDIM SHARED LISTDATA(38, 3)

REDIM SHARED COOKIEPTN(21, 25)
REDIM SHARED JSVPTN(69, 20)
REDIM SHARED NEWFONT$(32 TO 126)

REDIM SHARED DEMO1PTN(22)
REDIM SHARED DEMO2PTN(20)
REDIM SHARED DEMO3PTN(5)
REDIM SHARED DEMO4PTN(123)

'- main -
INITGRAPHIC
INITMAINVARIABLE

LOGO
TITLE

SYSTEM

SUB ADJUSTEYE (P)

 FOR I = 1 TO 3
   IF P = I THEN
     P = P + 1
     UPDATEBLINK (P), VISPAGE
     DELAY 1
   END IF
 NEXT

END SUB

FUNCTION BUTTON (P)

 RESULT = 0
 IF JOY.STICKFOUND THEN
   RESULT = (INP(&H201) AND (2 ^ (3 + P))) = 0
 END IF

 BUTTON = RESULT

END FUNCTION

SUB CALSTICK

 IF JOY.STICKFOUND THEN
   '- initialize -
   QUIT = FALSE

   STICKMINX = &H7FFF
   STICKMINY = &H7FFF
   STICKMAXX = &HFFFF8000
   STICKMAXY = &HFFFF8000

   '- clear menu area -
   ERASEBOX

   '- draw box -
   LINE (182, 18)-(284, 124), 1, B
   LINE (181, 19)-(285, 123), 1, B
   LINE (180, 20)-(286, 122), 1, B
   LINE (183, 21)-(283, 121), 15, BF
   PSET (183, 21), 1: PSET (183, 121), 1
   PSET (283, 21), 1: PSET (283, 121), 1
   DRAW "BM172,60 C1BR8R2DL2GR3GL3GR3GL3GR3G"
   DRAW "L3GR8FL10FR9DL2DR2C15BU4U5GD3LU2GDL"

   '- blink eye one more time -
   FOR I = 1 TO 4
     UPDATEBLINK (I), VISPAGE
     DELAY 1
   NEXT

   '- say message(s) -
   TALK "Please! Move ", "1010100011000", 0
   TALK "stick in all ", "1100001001100", 1
   TALK " directions  ", "0110111011100", 2
   TALK " then press  ", "0100001101000", 3
   TALK " any buttons ", "0101010101010", 4
   TALK "  or press   ", "0010011010000", 5
   TALK "[Esc] key to ", "0111001000100", 6
   TALK "   cancel.   ", "0001001100000", 7

   '- main -
   DO
     STICKY = 0
     STICKX = 0
     DUMMY = 0

     '- get key board -
     KEY$ = INKEY$: DUMMY = RND(1)
     IF KEY$ = CHR$(27) THEN QUIT = TRUE

     '- get button(s) -
     TR = BUTTON(1) OR BUTTON(2)

     '- calculate Min,Max stick value -
     OUT &H201, 0
     DO
       STICKDATA = INP(&H201)
       IF (STICKDATA AND 1) THEN STICKX = STICKX + 1 ELSE DUMMY = DUMMY + 1
       IF (STICKDATA AND 2) THEN STICKY = STICKY + 1 ELSE DUMMY = DUMMY + 1
     LOOP UNTIL ((STICKDATA AND &H1) OR (STICKDATA AND &H2)) = 0

     IF STICKX < STICKMINX THEN STICKMINX = STICKX
     IF STICKX > STICKMAXX THEN STICKMAXX = STICKX
     IF STICKY < STICKMINY THEN STICKMINY = STICKY
     IF STICKY > STICKMAXY THEN STICKMAXY = STICKY

     STICKCENX = (STICKMAXX + STICKMINX) \ 2
     STICKCENY = (STICKMAXY + STICKMINY) \ 2

     '- calculate Max, Min range -
     JOY.STICKMINY = STICKCENY - ((STICKCENY - STICKMINY) * .7)
     JOY.STICKMAXY = ((STICKMAXY - STICKCENY) * .7) + STICKCENY
     JOY.STICKMINX = STICKCENX - ((STICKCENX - STICKMINX) * .7)
     JOY.STICKMAXX = ((STICKMAXX - STICKCENX) * .7) + STICKCENX

     '- output -
     ANGLE = 0
     IF STICKY <= JOY.STICKMINY THEN ANGLE = 1
     IF STICKX >= JOY.STICKMAXX THEN ANGLE = 3
     IF STICKY >= JOY.STICKMAXY THEN ANGLE = 5
     IF STICKX <= JOY.STICKMINX THEN ANGLE = 7
     IF STICKY <= JOY.STICKMINY AND STICKX >= JOY.STICKMAXX THEN ANGLE = 2
     IF STICKX >= JOY.STICKMAXX AND STICKY >= JOY.STICKMAXY THEN ANGLE = 4
     IF STICKX <= JOY.STICKMINX AND STICKY >= JOY.STICKMAXY THEN ANGLE = 6
     IF STICKY <= JOY.STICKMINX AND STICKX <= JOY.STICKMINX THEN ANGLE = 8

     UPDATEEYE ANGLE, VISPAGE

     DELAY 1

   LOOP UNTIL TR OR QUIT
   JOY.CALIBRATED = (NOT QUIT)

   UPDATEBLINK (0), VISPAGE

   '- clear box -
   ERASEBOX

 END IF

END SUB

SUB DELAY (P)

 STATIC OLDSPEED!
 FOR I = 1 TO P
   DO
     SPEED! = TIMER
   LOOP UNTIL SPEED! <> OLDSPEED!
   OLDSPEED! = SPEED!
 NEXT

END SUB

SUB DEMO (N, JSVSCORE&)

 SELECT CASE N
 CASE 1
   '- candy talk -
   SCREEN , , DEMOPAGE, VISPAGE
   GET (1 + (0 * 103), 1)-(102 + (0 * 103), 61), FMVDATA
   SCREEN , , AUXPAGE, VISPAGE
   PUT (0, 0), FMVDATA, PSET
   UPDATEDEMO 63, 29, 0, AUXPAGE

   DEMOFX
   DELAY 20

   '- animation(pick up) -
   FOR I = 1 TO DEMO1PTN(0)
     UPDATEDEMO 243, 77, DEMO1PTN(I), VISPAGE
     DELAY 1
   NEXT
   DELAY 10
   GET (180, 48)-(281, 76), FMVDATA
   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM263,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Hey! Cookie!"
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "Deliver this"
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "package to"
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "Mr. JAWS-V."
   DELAY 20
   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   '- staff (programmer) -
   SCREEN , , 3, VISPAGE
   GET (104, 110 + (0 * 20))-(181, 128 + (0 * 20)), FMVDATA
   SCREEN , , AUXPAGE, VISPAGE
   LINE ((0 * 103), 0)-(101 + (0 * 103), 60), 15, BF
   PUT (11, 20), FMVDATA, PSET

   DEMOFX
   DELAY 40

   '- hammer ! -
   SCREEN , , DEMOPAGE, VISPAGE
   GET (1 + (0 * 103), 1)-(102 + (0 * 103), 61), FMVDATA
   SCREEN , , AUXPAGE, VISPAGE
   PUT (0, 0), FMVDATA, PSET
   UPDATEDEMO 48, 29, 9, AUXPAGE

   DEMOFX
   DELAY 20

   GET (180, 48)-(281, 76), FMVDATA
   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM263,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Be careful."
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "There are many"
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "ghosts in "
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "that building."
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 20
   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM229,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Don't worry."
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "I have this !"
   DELAY 5

   '- animation(smash) -
   FOR I = 1 TO DEMO2PTN(0)
     UPDATEDEMO 228, 77, DEMO2PTN(I), VISPAGE
     DELAY 1
   NEXT

   DELAY 10
   PUT (180, 48), FMVDATA, PSET
   DELAY 20

   '- staff (dot artist) -
   SCREEN , , 3, VISPAGE
   GET (104, 110 + (1 * 20))-(181, 128 + (1 * 20)), FMVDATA
   SCREEN , , AUXPAGE, VISPAGE
   LINE ((0 * 103), 0)-(101 + (0 * 103), 60), 15, BF
   PUT (11, 20), FMVDATA, PSET

   DEMOFX
   DELAY 40

   '- building -
   SCREEN , , DEMOPAGE, VISPAGE
   GET (1 + (1 * 103), 1)-(102 + (1 * 103), 61), FMVDATA
   SCREEN , , AUXPAGE, VISPAGE
   PUT (0, 0), FMVDATA, PSET

   DEMOFX
   DELAY 20

   '- animation(CHANGE V appear) -
   FOR I = 1 TO DEMO3PTN(0)
     UPDATEDEMO 229, 77, DEMO3PTN(I), VISPAGE
     DELAY 1
   NEXT
   DELAY 20

   GET (186 - 6, 51 - 3)-(185 + 90 + 6, 51 + 16 + 9), FMVDATA
   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM241,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Help...."
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "Help...."
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "Heeeeeeeelp !"
   DELAY 40

   PUT (186 - 6, 51 - 3), FMVDATA, PSET
   DELAY 20

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM241,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Too.. Many.."
   DELAY 30
   DRAWNEWFONT 186, 60, 1, 0, 0, "Ghosts...."
   DELAY 30
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "in... the..."
   DELAY 30
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "building !!!"
   DELAY 30

   PUT (180, 48), FMVDATA, PSET
   DELAY 20

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM262,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Don't worry."
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "I will"
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "exterminate "
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "them for FREE"
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 20

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM241,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Who are you ?"
   DELAY 30

   PUT (180, 48), FMVDATA, PSET
   DELAY 20

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM262,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Me ?"
   DELAY 30
   DRAWNEWFONT 186, 60, 1, 0, 0, "I am..."
   DELAY 30
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "a..."
   DELAY 30
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "Ghost Smasher !"
   DELAY 30

   PUT (180, 48), FMVDATA, PSET
   DELAY 20

   '- staff (producer) -
   SCREEN , , 3, VISPAGE
   GET (104, 110 + (2 * 20))-(181, 128 + (2 * 20)), FMVDATA
   SCREEN , , AUXPAGE, VISPAGE
   LINE ((0 * 103), 0)-(101 + (0 * 103), 60), 15, BF
   PUT (11, 20), FMVDATA, PSET

   DEMOFX
   DELAY 40

   SCREEN , , 3, VISPAGE
   GET (1, 110)-(102, 170), FMVDATA
   SCREEN , , AUXPAGE, VISPAGE
   PUT (0, 0), FMVDATA, PSET

   DEMOFX
   DELAY 10

 CASE IS = 2
   SCREEN , , DEMOPAGE, VISPAGE
   GET (1 + (2 * 103), 1)-(102 + (2 * 103), 61), FMVDATA
   SCREEN , , AUXPAGE, VISPAGE
   PUT (0, 0), FMVDATA, PSET

   DEMOFX
   DELAY 20

   FOR I = 1 TO DEMO4PTN(0)
     UPDATEDEMO 207, 77, DEMO4PTN(I), VISPAGE
     DELAY 1
   NEXT
   DELAY 5

   GET (180, 48)-(281, 76), FMVDATA
   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM207,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Yikes."
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "Another ghost?"
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 20

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM248,70 C01 D3GDNGRERE3UBU C15 L5FR3DL3DR2GLG"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Hey. I'm not a"
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "GHOST."
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM248,70 C01 D3GDNGRERE3UBU C15 L5FR3DL3DR2GLG"
   DRAWNEWFONT 186, 51, 1, 0, 0, "I am a"
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "Producer"
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "of this game !"
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM248,70 C01 D3GDNGRERE3UBU C15 L5FR3DL3DR2GLG"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Who are you ?"
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM207,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "I'm Cookie."
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "I'm here to"
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "deliver this"
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "package"
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM248,70 C01 D3GDNGRERE3UBU C15 L5FR3DL3DR2GLG"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Package ?"
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, ". . . . . ."
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "What package ?"
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM207,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "You ordered the"
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "box of cookies!"
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM248,70 C01 D3GDNGRERE3UBU C15 L5FR3DL3DR2GLG"
   DRAWNEWFONT 186, 51, 1, 0, 0, "No. I didn't"
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM207,70 C01 bl2 FDFDFNDEUEUEBH C15 L4DR4GL2DR2GD"
   DRAWNEWFONT 186, 51, 1, 0, 0, "Yikes"
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "It must be"
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "ghost's ..."
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "... ... ..."
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM248,70 C01 D3GDNGRERE3UBU C15 L5FR3DL3DR2GLG"
   DRAWNEWFONT 186, 51, 1, 0, 0, ". . . . . ."
   DELAY 20
   DRAWNEWFONT 186, 60, 1, 0, 0, "Ghosts ...?"
   DELAY 20
   SCROLLTEXT
   DRAWNEWFONT 186, 60, 1, 0, 0, "What ghosts?"
   DELAY 20

   PUT (180, 48), FMVDATA, PSET
   DELAY 20

   '- animation (object)-
   FOR I = 1 TO JSVPTN(1, 0)
     UPDATEOBJECT 255, 69, JSVPTN(1, I), VISPAGE
     DELAY 1
   NEXT
   DELAY 10
   FOR I = 1 TO JSVPTN(2, 0)
     UPDATEOBJECT 255, 69, JSVPTN(2, I), VISPAGE
     DELAY 1
   NEXT
   DELAY 10
   SCREEN , , DEMOPAGE, VISPAGE
   GET (298, 63)-(308, 92), FMVDATA
   SCREEN , , VISPAGE, VISPAGE
   PUT (257, 75), FMVDATA, PSET
   DELAY 10
   UPDATEOBJECT 255, 69, 2, VISPAGE
   DELAY 10

   GET (180, 48)-(281, 76), FMVDATA
   DRAW "BM185,49 C13 R91FRFDFD12GDGLGL91HLHUHU12EUER BR P1,13 P15,13"
   DRAW "BM185,49 C01 R91FRFDFD12GDGLGL91HLHUHU12EUER"
   DRAW "BM250,70 C01 D3FDNFLHLH3UBU C15 R5GL3DR3DL2FRF"
   
   DRAWNEWFONT 186, 51, 1, 0, 0, "You smashed    "
   DRAWNEWFONT 186, 60, 1, 0, 0, LTRIM$(STR$(JSVSCORE&)) + " ghosts!"
   DELAY 70
   SCROLLTEXT
   SCROLLTEXT
   DRAWNEWFONT 186, 56, 1, 0, 0, " T H E   E N D"
   DELAY 70

   PUT (180, 48), FMVDATA, PSET
   DELAY 30

   SCREEN , , 3, VISPAGE
   GET (1, 110)-(102, 170), FMVDATA
   SCREEN , , AUXPAGE, VISPAGE
   PUT (0, 0), FMVDATA, PSET

   DEMOFX
   DELAY 30

 CASE IS = 3
   SCREEN 0
   WIDTH 80, 50
   LOADSCR "MISC1", 1
   LOADSCR "MISC2", 2

   COUNTER = 7
   DO
     COUNTER = (COUNTER + 1) MOD 50
     PCOPY VAL(MID$("11100111", COUNTER + 1, 1)) + 1, VISPAGE
     DELAY 1
   LOOP UNTIL INKEY$ <> "" OR BUTTON(1) OR BUTTON(2)
   PCOPY 1, VISPAGE
 END SELECT

END SUB

SUB DEMOFX

 FOR I = 0 TO 100 STEP 6
   SCREEN , , AUXPAGE, VISPAGE
   GET (I, 0)-(I + 2, 60), FMVDATA
   GET (99 - I, 0)-(101 - I, 60), FMVMASK
   SCREEN , , VISPAGE, VISPAGE
   PUT (180 + I, 48), FMVDATA, PSET
   PUT (279 - I, 48), FMVMASK, PSET
   DELAY 1
 NEXT

END SUB

SUB DRAWBACKGROUND (SCORE&, HISCORE&, JSVSCORE&, JSVNUM&)

 SCREEN , , BACKGROUNDPAGE, VISPAGE
 CLS
 LINE (0, 16)-(319, 199), 14, BF
 LINE (0, 16)-(0, 199), 5
 LINE (319, 16)-(319, 199), 5
 LINE (0, 19)-(319, 57), 5, B
 LINE (0, 64)-(319, 102), 5, B
 LINE (0, 109)-(319, 147), 5, B
 LINE (0, 154)-(319, 192), 5, B
 LINE (0, 199)-(319, 199), 5
 LINE (1, 16)-(318, 18), 3, BF
 LINE (1, 58)-(318, 63), 3, BF
 LINE (1, 103)-(318, 108), 3, BF
 LINE (1, 148)-(318, 153), 3, BF
 LINE (1, 193)-(318, 198), 3, BF
 UPDATEDOOR 0, BACKGROUNDPAGE

 '- ghost counter -
 DRAW "BM255,0C1BM+3,+1R4ER2FD4NH3DHD4GH2GDREFDGDFDL2ULGL2UERUH2L2U"
 DRAW "EFUERNE2L4HUEUEFDBR2NUBH2C5FUR3GR2EHR2D2GD2HUL2DLHDL2NU2LDR4"
 DRAW "FERGR2NG2D2GDGULHUEL2DBL2R0BR2DF2DGNLERFBE5C15RDLBD2RDLBE4"

 '- score -
 UPDATESCORE SCORE&, 0, BACKGROUNDPAGE
 UPDATESCORE HISCORE&, 1, BACKGROUNDPAGE
 UPDATESCORE JSVSCORE&, 2, BACKGROUNDPAGE
 UPDATESCORE JSVNUM&, 3, BACKGROUNDPAGE

END SUB

SUB DRAWNEWFONT (X, Y, C1, C2, S, S$)

 DRAW "BM" + STR$(X) + "," + STR$(Y)
 FOR I = 1 TO LEN(S$)
   IF C2 THEN '- erase back ground -
     DRAW "C" + STR$(C2) + "NR6DNR6DNR6DNR6DNR6DNR6DNR6DNR6U7"
   END IF
   IF C1 THEN '- write text -
     DRAW "C" + STR$(C1) + NEWFONT$(ASC(MID$(S$, I, 1))) + "BR" + STR$(S)
   END IF
 NEXT

END SUB

SUB DRAWPLATE (X, Y, P, P2)

 SCREEN , , P2, VISPAGE
 DRAW "BM" + STR$(X) + "," + STR$(Y)
 IF P = 0 THEN
   DRAW "C14 BRR22FDGL22HU"
   DRAW "C14 BRR22DL22"
 ELSE
   DRAW "C 5 BRR22FDGL22HU"
   DRAW "C15 BRR22DL22"
 END IF

END SUB

SUB ERASEBOX

 SCREEN , , VISPAGE, VISPAGE
 FOR I = 0 TO 19 STEP 4
   FOR J = 0 TO 7
     LINE (152 + (J * 20) + I, 10)-(155 + (J * 20) + I, 199), 0, BF
   NEXT
   DELAY 1
 NEXT
 DELAY 1

END SUB

SUB FADE (P)

 FADESTEP = (8 \ 1) - 1
 SELECT CASE P
 CASE IS = 0   '- fade color to black -
   FOR J = 0 TO FADESTEP
     OUT &H3C8, 0
     FOR I = 0 TO 23
       VALUE1 = VAL(MID$("250009270918451800000000000000006363545509004563", I * 2 + 1, 2))
       OUT &H3C9, VALUE1 - (VALUE1 / FADESTEP * J)
       VALUE1 = VAL(MID$("260054630927095400000000000000000921545436004563", I * 2 + 1, 2))
       OUT &H3C9, VALUE1 - (VALUE1 / FADESTEP * J)
       VALUE1 = VAL(MID$("270009276363096300000000000000000921093609004563", I * 2 + 1, 2))
       OUT &H3C9, VALUE1 - (VALUE1 / FADESTEP * J)
     NEXT
     DELAY 1
   NEXT

 CASE IS = 1   '- fade black to color -
   FOR J = FADESTEP TO 0 STEP -1
     OUT &H3C8, 0
     FOR I = 0 TO 23
       VALUE1 = VAL(MID$("250009270918451800000000000000006363545509004563", I * 2 + 1, 2))
       OUT &H3C9, VALUE1 - (VALUE1 / FADESTEP * J)
       VALUE1 = VAL(MID$("260054630927095400000000000000000921545436004563", I * 2 + 1, 2))
       OUT &H3C9, VALUE1 - (VALUE1 / FADESTEP * J)
       VALUE1 = VAL(MID$("270009276363096300000000000000000921093609004563", I * 2 + 1, 2))
       OUT &H3C9, VALUE1 - (VALUE1 / FADESTEP * J)
     NEXT
     DELAY 1
   NEXT
 END SELECT

END SUB

SUB GAME (RESULT, SCORE&, HISCORE&, JSVSCORE&, JSVNUM&, MAXOBJ)

 REDIM JSVISWORKING(1 TO MAXJSV)
 REDIM JSVTIMER(1 TO MAXJSV)

 REDIM JSVX(1 TO MAXJSV)
 REDIM JSVY(1 TO MAXJSV)
 REDIM JSVOBJNO(1 TO MAXJSV)
 REDIM JSVDIR(1 TO MAXJSV)
 REDIM JSVSTATE(1 TO MAXJSV)
 REDIM JSVOLDOBJPOS(1 TO MAXJSV)
 REDIM JSVATK(1 TO MAXJSV)

 REDIM JSVCELCOUNTER(1 TO MAXJSV)
 REDIM JSVCELCOUNTERMAX(1 TO MAXJSV)
 REDIM JSVACTION(1 TO MAXJSV)

 REDIM JSVATKTIMER(1 TO MAXJSV)
 REDIM JSVHITTIMER(1 TO MAXJSV)
 REDIM JSVFLAMEX(1 TO MAXJSV)
 REDIM JSVFLAMEY(1 TO MAXJSV)
 REDIM JSVFLAMEPTN(1 TO MAXJSV)
 REDIM JSVFLAMEDIR(1 TO MAXJSV)

 '- init Jsv-Obj(ghost) Timer -
 FOR I = 1 TO MAXJSV
   JSVISWORKING(I) = FALSE
   JSVTIMER(I) = INT(RND(1) * 50) + 1 + ((I - 1) * 30)
 NEXT

 OBJREMAIN = MAXOBJ
 FREEOBJ = MAXOBJ

 REDIM OBJNUM(1 TO MAXOBJ)
 REDIM OBJX(1 TO MAXOBJ)
 REDIM OBJY(1 TO MAXOBJ)
 REDIM OBJUSEDFLAG(1 TO MAXOBJ)
 REDIM OBJLINK(1 TO MAXOBJ)

 COUNTER = 0
 FOR J = 0 TO 3
   FOR I = 0 TO 9
     OBJECT = LEVELARRAY(I * 4 + 1, J)
     IF ((OBJECT > 0) AND (OBJECT < 8)) THEN
       COUNTER = COUNTER + 1
       OBJNUM(COUNTER) = OBJECT
       OBJX(COUNTER) = I
       OBJY(COUNTER) = J
       OBJUSEDFLAG(COUNTER) = 0
       OBJLINK(COUNTER) = 0
     END IF
   NEXT
 NEXT

 RESULT = 0

 GAMEDATA.MUTEKI = FALSE
 GAMEDATA.DEBUG = FALSE

 STAGECLEAR = FALSE
 HIT = FALSE
 SELECTEDQUIT = FALSE
 SELECTEDCONT = FALSE
 DOORACTION = 0
 DOOROPENED = FALSE
 CONTROL = TRUE

 '- cookie init -
 COOKIEX = 1                 'X ON SCREEN
 COOKIEY = 172               'Y ON SCREEN
 COOKIEDIR = 1               'DIRECTION 0=L,1=R
 COOKIEACTION = 0            'NORMAL
 COOKIEACTIONNUM = 8
 COOKIECEL = COOKIEPTN(COOKIEACTIONNUM, 1)
 COOKIECELCOUNTER = 0
 COOKIEMAXCELNUM = COOKIEPTN(COOKIEACTIONNUM, 0)
 COOKIEMAPX = 1              'X ON MAP
 COOKIEMAPY = 3              'Y ON MAP

 SUBDEMO 0

 '- main game loop -
 DO
   PCOPY BACKGROUNDPAGE, AUXPAGE

   A$ = INKEY$: DUMMY = RND(1)
   IF CONTROL THEN
     '- get key board -
     IF LEN(A$) = 2 THEN A$ = "*" + RIGHT$(A$, 1)
     IF A$ = CHR$(27) THEN CANCELED = TRUE
     ST = JOYPAD
     TR = BUTTON(1) OR BUTTON(2)
     IF NOT TR THEN BUTTONRELEASED = TRUE

     '- check stick & button(s) -
     IF JOY.STICKON THEN
       IF ST = 1 THEN A$ = "*H"
       IF ST = 5 THEN A$ = "*P"
       IF ST = 2 OR ST = 3 OR ST = 4 THEN A$ = "*M"
       IF ST = 6 OR ST = 7 OR ST = 8 THEN A$ = "*K"
     END IF

     IF TR AND BUTTONRELEASED THEN
        BUTTONRELEASED = FALSE
        A$ = " "
     END IF
   ELSE
     A$ = ""
   END IF

   '- check QUIT -
   IF A$ = CHR$(27) THEN
     SUBMENU 1, SELECTEDQUIT
     IF SELECTEDQUIT THEN
       CONTROL = FALSE
       COOKIEACTION = 8              'CRY
       COOKIEACTIONNUM = 5 + COOKIEDIR * 8
       COOKIECELCOUNTER = 0
       COOKIEMAXCELNUM = COOKIEPTN(COOKIEACTIONNUM, 0)
       GAMEDATA.MUTEKI = FALSE
       GLOW 0
     END IF
   END IF

   IF A$ = "*;" THEN
     GAMEDATA.DEBUG = NOT GAMEDATA.DEBUG
   END IF
   
   IF GAMEDATA.MUTEKI THEN
     MUTEKIFX = (MUTEKIFX + 1) MOD 16
     GLOW MUTEKIFX
   END IF

   IF A$ = "*" + CHR$(134) THEN
     GAMEDATA.MUTEKI = NOT GAMEDATA.MUTEKI
     MUTEKIFX = 0
     GLOW MUTEKIFX
   END IF

   IF A$ = "*M" THEN
     IF COOKIEDIR = 0 THEN           'ROTATE
       CONTROL = FALSE
       COOKIEACTION = 2              'rotation
       COOKIEDIR = 1 - COOKIEDIR     'direction 0=L,1=R
       COOKIEACTIONNUM = 4
       COOKIECELCOUNTER = 0
       COOKIEMAXCELNUM = COOKIEPTN(COOKIEACTIONNUM, 0)
     ELSE
       CONTROL = FALSE
       COOKIEACTION = 1              'ACTION 1 = WALK
       COOKIEWALKSTEP = 1 - COOKIEWALKSTEP
       COOKIEACTIONNUM = 9 + COOKIEWALKSTEP
       COOKIECELCOUNTER = 0
       COOKIEMAXCELNUM = COOKIEPTN(COOKIEACTIONNUM, 0)
     END IF
   END IF

   IF A$ = "*K" THEN
     IF COOKIEDIR = 1 THEN           'ROTATE
       CONTROL = FALSE
       COOKIEACTION = 4              'rotation
       COOKIEDIR = 1 - COOKIEDIR     'direction 0=L,1=R
       COOKIEACTIONNUM = 12
       COOKIECELCOUNTER = 0
       COOKIEMAXCELNUM = COOKIEPTN(COOKIEACTIONNUM, 0)
     ELSE
       CONTROL = FALSE
       COOKIEACTION = 3              'ACTION 1 = WALK
       COOKIEWALKSTEP = 1 - COOKIEWALKSTEP
       COOKIEACTIONNUM = 1 + COOKIEWALKSTEP
       COOKIECELCOUNTER = 0
       COOKIEMAXCELNUM = COOKIEPTN(COOKIEACTIONNUM, 0)
     END IF
   END IF

   IF A$ = "*H" AND LEVELARRAY(COOKIEMAPX, COOKIEMAPY) = 8 THEN
     CONTROL = FALSE
     COOKIEACTION = 6
     COOKIEACTIONTIMER = 15     '- while timer, move plate -
     ELEVX = COOKIEMAPX * 8 - 5
     ELEVY = COOKIEMAPY * 45 + 57
     ' - erase old plate -
     DRAWPLATE ELEVX, ELEVY, 0, BACKGROUNDPAGE
   END IF

   IF A$ = "*P" AND LEVELARRAY(COOKIEMAPX, COOKIEMAPY) = 9 THEN
     CONTROL = FALSE
     COOKIEACTION = 7
     COOKIEACTIONTIMER = 15     '- while timer, move plate -
     ELEVX = COOKIEMAPX * 8 - 5
     ELEVY = COOKIEMAPY * 45 + 57
     ' - erase old plate -
     DRAWPLATE ELEVX, ELEVY, 0, BACKGROUNDPAGE
   END IF

   IF A$ = " " OR T THEN  '- attack -
     CONTROL = FALSE
     COOKIEACTION = 5
     COOKIEACTIONNUM = 3 + COOKIEDIR * 8
     COOKIECELCOUNTER = 0
     COOKIEMAXCELNUM = COOKIEPTN(COOKIEACTIONNUM, 0)
   END IF

   '- cookie animation -
   SELECT CASE COOKIEACTION
   CASE IS = 1  '- walk => -
     '- if cell counter <> max cell -
     IF COOKIECELCOUNTER < COOKIEMAXCELNUM THEN
       '- cell counter++ -
       COOKIECELCOUNTER = COOKIECELCOUNTER + 1
       '- calculate cell number -
       COOKIECEL = COOKIEPTN(COOKIEACTIONNUM, COOKIECELCOUNTER)
       '- adjust x -
       COOKIEX = COOKIEX + 2
       IF COOKIEX >= 289 THEN COOKIEX = 289
       '- reaches max cell then (final animation) -
       IF COOKIECELCOUNTER >= COOKIEMAXCELNUM THEN
         '- update map x -
         COOKIEMAPX = COOKIEMAPX + 1 + (COOKIEMAPX = 37)
         '- restore control -
         CONTROL = TRUE
         '- no action (stand still) -
         COOKIEACTION = 0
       END IF
     END IF

   CASE IS = 2  '- ROTATE => TO <= -
     '- if cell counter <> max cell -
     IF COOKIECELCOUNTER < COOKIEMAXCELNUM THEN
       '- cell counter++ -
       COOKIECELCOUNTER = COOKIECELCOUNTER + 1
       '- calculate cell number -
       COOKIECEL = COOKIEPTN(COOKIEACTIONNUM, COOKIECELCOUNTER)
       '- reaches max cell then (final animation) -
       IF COOKIECELCOUNTER >= COOKIEMAXCELNUM THEN
         '- restore control -
         CONTROL = TRUE
         '- no action (stand still) -
         COOKIEACTION = 0
       END IF
     END IF

   CASE IS = 3  '- walk <= -
     '- if cell counter <> max cell -
     IF COOKIECELCOUNTER < COOKIEMAXCELNUM THEN
       '- cell counter++ -
       COOKIECELCOUNTER = COOKIECELCOUNTER + 1
       '- calculate cell number -
       COOKIECEL = COOKIEPTN(COOKIEACTIONNUM, COOKIECELCOUNTER)
       '- adjust x -
       COOKIEX = COOKIEX - 2
       IF COOKIEX <= 1 THEN COOKIEX = 1
       '- reaches max cell then (final animation) -
       IF COOKIECELCOUNTER >= COOKIEMAXCELNUM THEN
         '- update map x -
         COOKIEMAPX = COOKIEMAPX - 1 - (COOKIEMAPX = 1)
         '- restore control -
         CONTROL = TRUE
         '- no action (stand still) -
         COOKIEACTION = 0
       END IF
     END IF

   CASE IS = 4  '- ROTATE <= TO => -
     '- if cell counter <> max cell -
     IF COOKIECELCOUNTER < COOKIEMAXCELNUM THEN
       '- cell counter++ -
       COOKIECELCOUNTER = COOKIECELCOUNTER + 1
       '- calculate cell number -
       COOKIECEL = COOKIEPTN(COOKIEACTIONNUM, COOKIECELCOUNTER)
       '- reaches max cell then (final animation) -
       IF COOKIECELCOUNTER >= COOKIEMAXCELNUM THEN
         '- restore control -
         CONTROL = TRUE
         '- no action (stand still) -
         COOKIEACTION = 0
       END IF
     END IF

   CASE IS = 5  '- ATTACK -
     '- if cell counter <> max cell -
     IF COOKIECELCOUNTER < COOKIEMAXCELNUM THEN
       '- cell counter++ -
       COOKIECELCOUNTER = COOKIECELCOUNTER + 1
       '- calculate cell number -
       COOKIECEL = COOKIEPTN(COOKIEACTIONNUM, COOKIECELCOUNTER)
       '- wow ! cookie attack detection !! -
       HAMMERX = -1
       HAMMERY = -1
       MAPSTATE = 0
       LINKSTATE = 0
       LISTSTATE = 0
       IF COOKIECELCOUNTER = 6 THEN
         IF ((COOKIEMAPX + 2 - (COOKIEDIR * 2)) MOD 4) = 0 THEN
           HAMMERX = ((COOKIEMAPX + 2 + (COOKIEDIR * 2)) \ 4) - 1
           HAMMERY = COOKIEMAPY
           MAPSTATE = MAPDATA(HAMMERX, HAMMERY)
           IF MAPSTATE = 1 THEN    '- (hit obj 1) -
             LISTSTATE = LISTDATA(HAMMERX, HAMMERY)
             '- object reset -
             MAPDATA(HAMMERX, HAMMERY) = 3
             FREEOBJ = FREEOBJ - 1
             OBJREMAIN = OBJREMAIN - 1
             IF OBJREMAIN <= 0 THEN DOORACTION = 1
             OBJUSEDFLAG(LISTSTATE) = 2
             '- update broken object -
             JX = HAMMERX * 32 + 6
             JY = HAMMERY * 45 + 21
             JP = JSVPTN((OBJNUM(LISTSTATE) - 1) * 10 + 5, 1)
             UPDATEOBJECT JX, JY, JP, BACKGROUNDPAGE
             '- score +1 pts -
             SCORE& = SCORE& + 1 + (SCORE& = 9999999)
             UPDATESCORE SCORE&, 0, BACKGROUNDPAGE
             IF SCORE& > HISCORE& THEN
               HISCORE& = SCORE&
               UPDATESCORE HISCORE&, 1, BACKGROUNDPAGE
             END IF
           END IF
           IF MAPSTATE = 2 THEN    '- (hit obj 2) -
             LINKSTATE = LINKDATA(HAMMERX, HAMMERY)
             LISTSTATE = LISTDATA(HAMMERX, HAMMERY)
             '- object reset -
             MAPDATA(HAMMERX, HAMMERY) = 4  ' - broken obj + jsv -
             OBJREMAIN = OBJREMAIN - 1
             IF OBJREMAIN <= 0 THEN DOORACTION = 1
             OBJUSEDFLAG(LISTSTATE) = 2
             OBJLINK(LISTSTATE) = 0
             '- update broken object -
             JX = HAMMERX * 32 + 6
             JY = HAMMERY * 45 + 21
             JP = JSVPTN((OBJNUM(LISTSTATE) - 1) * 10 + 5, 1)
             UPDATEOBJECT JX, JY, JP, BACKGROUNDPAGE
             '- score +50 pts -
             SCORE& = SCORE& + 50
             IF SCORE& >= 9999999 THEN SCORE& = 9999999
             UPDATESCORE SCORE&, 0, BACKGROUNDPAGE
             IF SCORE& > HISCORE& THEN
               HISCORE& = SCORE&
               UPDATESCORE HISCORE&, 1, BACKGROUNDPAGE
             END IF
             JSVNUM& = JSVNUM& + 1 + (JSVNUM& = 99)
             UPDATESCORE JSVNUM&, 3, BACKGROUNDPAGE

             '- now.. reset jsv(yikes!) -
             JSVISWORKING(LINKSTATE) = FALSE
             LINKDATA(JSVX(LINKSTATE), JSVY(LINKSTATE)) = 0
             JSVX(LINKSTATE) = 0
             JSVY(LINKSTATE) = 0
             JSVOBJNO(LINKSTATE) = 0
             JSVDIR(LINKSTATE) = 0
             JSVSTATE(LINKSTATE) = 0
             JSVISWORKING(LINKSTATE) = FALSE
             JSVTIMER(LINKSTATE) = INT(RND(1) * 100) + 1
             JSVOLDOBJPOS(LINKSTATE) = 0
             JSVATK(LINKSTATE) = 0
          
             IF NOT OUCH THEN  '- ouch init -
               OUCH = TRUE
               OUCHTIMER = 5
               OUCHX = HAMMERX * 32 + 5
               OUCHY = HAMMERY * 45 + 25
             END IF
           END IF

           IF NOT SUN AND (MAPSTATE <> 0) THEN '- SUN init -
             SUN = TRUE
             SUNCOUNTER = -1
             SUNX = HAMMERX * 32 + 8 + (INT(RND * 3) - 1)
             SUNY = HAMMERY * 45 + 46 + (INT(RND * 3) - 1)
           END IF

           IF NOT OUCH AND (MAPSTATE = 4) THEN '- ouch init -
             OUCH = TRUE
             OUCHTIMER = 5
             OUCHX = HAMMERX * 32 + 5
             OUCHY = HAMMERY * 45 + 25
           END IF

         END IF
       END IF
       '- reaches max cell then (final animation) -
       IF COOKIECELCOUNTER >= COOKIEMAXCELNUM THEN
         '- restore control -
         CONTROL = TRUE
         '- no action (stand still) -
         COOKIEACTION = 0
       END IF
     END IF

   CASE IS = 6
     IF COOKIEACTIONTIMER > 0 THEN
       COOKIEACTIONTIMER = COOKIEACTIONTIMER - 1
       COOKIEY = COOKIEY - 3
       ELEVY = ELEVY - 3
       IF COOKIEACTIONTIMER <= 0 THEN
         CONTROL = TRUE
         COOKIEACTION = 0
         '- restore plate -
         DRAWPLATE ELEVX, ELEVY, 1, BACKGROUNDPAGE
         COOKIEMAPY = COOKIEMAPY - 1 - (COOKIEMAPY = 0)
       END IF
     END IF

   CASE IS = 7
     IF COOKIEACTIONTIMER > 0 THEN
       COOKIEACTIONTIMER = COOKIEACTIONTIMER - 1
       COOKIEY = COOKIEY + 3
       ELEVY = ELEVY + 3
       IF COOKIEACTIONTIMER <= 0 THEN
         CONTROL = TRUE
         COOKIEACTION = 0
         '- restore plate -
         DRAWPLATE ELEVX, ELEVY, 1, BACKGROUNDPAGE
         COOKIEMAPY = COOKIEMAPY + 1 + (COOKIEMAPY = 3)
       END IF
     END IF

   CASE IS = 8 'QUIT (CRY:ROTATE)
     IF COOKIECELCOUNTER < COOKIEMAXCELNUM THEN
       '- cell counter++ -
       COOKIECELCOUNTER = COOKIECELCOUNTER + 1
       '- calculate cell number -
       COOKIECEL = COOKIEPTN(COOKIEACTIONNUM, COOKIECELCOUNTER)
       '- reaches max cell then (final animation) -
       IF COOKIECELCOUNTER >= COOKIEMAXCELNUM THEN
         COOKIEACTION = COOKIEACTION + 1
         COOKIEACTIONNUM = 6 + COOKIEDIR * 8
         COOKIECELCOUNTER = 0
         COOKIEMAXCELNUM = COOKIEPTN(COOKIEACTIONNUM, 0)
       END IF
     END IF

   CASE IS = 9 'QUIT (CRY)
     IF COOKIECELCOUNTER < COOKIEMAXCELNUM THEN
       '- cell counter++ -
       COOKIECELCOUNTER = COOKIECELCOUNTER + 1
       '- calculate cell number -
       COOKIECEL = COOKIEPTN(COOKIEACTIONNUM, COOKIECELCOUNTER)
       '- reaches max cell then (final animation) -
       IF COOKIECELCOUNTER >= COOKIEMAXCELNUM THEN
         COOKIEACTION = COOKIEACTION + 1
       END IF
     END IF

   CASE IS = 10 'QUIT (CRY)
     IF SELECTEDQUIT THEN
       RESULT = 3
     ELSE
       SUBMENU 0, SELECTEDCONT
       IF SELECTEDCONT THEN
         RESULT = 2
       ELSE
         RESULT = 3
       END IF
     END IF
   END SELECT

   '- check opened door and 'exit'. (stage clear !!)-
   IF COOKIEMAPX = 1 AND COOKIEMAPY = 3 AND DOOROPENED THEN
     RESULT = 1
     GAMEDATA.DEBUG = FALSE
     GAMEDATA.MUTEKI = FALSE
   END IF

   '- door section -
   PCOPY BACKGROUNDPAGE, AUXPAGE
   IF DOORACTION <> 0 AND NOT DOOROPENED THEN
     SELECT CASE DOORACTION
     CASE IS = 1 'init door
       DOORACTION = 2
       DOORPTN = -1

     CASE IS = 2 'animate door
       IF DOORPTN < 3 THEN
         DOORPTN = DOORPTN + 1
         SCREEN , , 1, VISPAGE
         GET (1 + (DOORPTN * 28), 127)-(27 + DOORPTN * 28, 155), FMVDATA
         GET (85, 157 + (DOORPTN * 8))-(107, 163 + (DOORPTN * 8)), FMVMASK
         SCREEN , , BACKGROUNDPAGE, VISPAGE
         PUT (2, 164), FMVDATA, PSET
         PUT (4, 156), FMVMASK, PSET
       ELSE
         DOOROPENED = TRUE
         DOORACTION = 0
       END IF
     END SELECT
   END IF

   '- JSV engine -
   FOR I = 1 TO MAXJSV
     IF FREEOBJ > 0 THEN
       IF JSVSTATE(I) = 0 THEN           'JSVSTATE=0 THEN CHECK TIMER,INIT
         IF JSVTIMER(I) > 0 THEN
           JSVTIMER(I) = JSVTIMER(I) - 1
         ELSE
           JSVISWORKING(I) = TRUE

           '- search free obj -
           RNDNUM = INT(RND(1) * FREEOBJ) + 1
           JSVPTR = 0                  '(OBJ=1 TO MAX,NOT 0 TO MAX-1)
           DO
             JSVPTR = JSVPTR + 1
             IF OBJUSEDFLAG(JSVPTR) = 0 THEN ' if obj is not used,skip
               RNDNUM = RNDNUM - 1
             END IF
           LOOP UNTIL RNDNUM <= 0
           JSVSTATE(I) = 1                'jsv is initialized
           JSVX(I) = OBJX(JSVPTR)
           JSVY(I) = OBJY(JSVPTR)
           JSVOBJNO(I) = OBJNUM(JSVPTR)
           MAPDATA(JSVX(I), JSVY(I)) = 2  'in the map, jsv is here
           JSVOLDOBJPOS(I) = JSVPTR

           '- calc dir -
           JX = JSVX(I) * 32 + 1
           IF JX <> COOKIEX THEN
              'normal dir
              JSVDIR(I) = -(JX < COOKIEX)
           ELSE
              'same position ...
              JSVDIR(I) = -(JSVX(I) < 5)
           END IF

           '- calc attack (Y/N) -
           IF ((JSVY(I) = (COOKIEY - 16) \ 45) AND RND(1) > .2) OR RND(1) < .5 THEN
             JSVATK(I) = TRUE
             JSVFLAMEDIR(I) = JSVDIR(I)
             JSVATKTIMER(I) = VAL(MID$("20212021222221", JSVOBJNO(I) * 2 - 1, 2))
             JSVFLAMEX(I) = JSVX(I) * 32 - 10 + JSVFLAMEDIR(I) * 31
             JSVFLAMEY(I) = JSVY(I) * 45 + VAL(MID$("38314343404744", JSVOBJNO(I) * 2 - 1, 2))
             JSVFLAMEPTN(I) = -1
           END IF

           FREEOBJ = FREEOBJ - 1
           OBJUSEDFLAG(JSVPTR) = 1
           OBJLINK(JSVPTR) = I
           LINKDATA(JSVX(I), JSVY(I)) = I
         END IF
       END IF
     END IF

     '- animate jsv -
     IF JSVISWORKING(I) THEN         'uninitialized jsv
       SELECT CASE JSVSTATE(I)       'check state,animate..
       CASE IS = 1
         ' [appear] init here
         JSVCELCOUNTER(I) = 1
         JSVACTION(I) = 1
         JSVCELCOUNTERMAX(I) = JSVPTN((JSVOBJNO(I) - 1) * 10 + JSVDIR(I) * 5 + JSVACTION(I), 0)
         JSVSTATE(I) = 2
         
       CASE IS = 2
         'animate [appear], check timer, init [taunt/attack]
         JSVCELCOUNTER(I) = JSVCELCOUNTER(I) + 1
         IF JSVCELCOUNTER(I) >= JSVCELCOUNTERMAX(I) THEN   'end animation #1
           JSVSTATE(I) = 3
           JSVCELCOUNTER(I) = 1
           JSVACTION(I) = 2 - (JSVATK(I)) * 2
           JSVCELCOUNTERMAX(I) = JSVPTN((JSVOBJNO(I) - 1) * 10 + JSVDIR(I) * 5 + JSVACTION(I), 0)
         END IF

       CASE IS = 3
         'animate [taunt/attack], check timer, init [disappear]
         JSVCELCOUNTER(I) = JSVCELCOUNTER(I) + 1
         IF JSVCELCOUNTER(I) >= JSVCELCOUNTERMAX(I) THEN   'end animation #1
           JSVSTATE(I) = 4
           JSVCELCOUNTER(I) = 1
           JSVACTION(I) = 3
           JSVCELCOUNTERMAX(I) = JSVPTN((JSVOBJNO(I) - 1) * 10 + JSVDIR(I) * 5 + JSVACTION(I), 0)
         END IF

       CASE IS = 4
         'animate [disappear], check timer, uninit [jsv]
         JSVCELCOUNTER(I) = JSVCELCOUNTER(I) + 1
         IF JSVCELCOUNTER(I) >= JSVCELCOUNTERMAX(I) THEN   'end animation #1
           JSVISWORKING(I) = FALSE
           MAPDATA(JSVX(I), JSVY(I)) = 1  'in the map, object is here
           LINKDATA(JSVX(I), JSVY(I)) = 0
           JSVX(I) = 0
           JSVY(I) = 0
           JSVOBJNO(I) = 0
           JSVDIR(I) = 0
           JSVSTATE(I) = 0
           JSVISWORKING(I) = FALSE
           JSVTIMER(I) = INT(RND(1) * 100) + 1
           FREEOBJ = FREEOBJ + 1
           OBJUSEDFLAG(JSVOLDOBJPOS(I)) = 0
           OBJLINK(JSVOLDOBJPOS(I)) = 0
           JSVOLDOBJPOS(I) = 0
         END IF
       END SELECT

       '- output jsv -
       IF JSVSTATE(I) >= 2 AND JSVSTATE(I) <= 9 THEN
         JX = JSVX(I) * 32 + 6
         JY = JSVY(I) * 45 + 21
         JP = JSVPTN((JSVOBJNO(I) - 1) * 10 + JSVDIR(I) * 5 + JSVACTION(I), JSVCELCOUNTER(I))
         UPDATEOBJECT JX, JY, JP, AUXPAGE
       END IF
     END IF
   NEXT

   '- output cookie -
   UPDATECOOKIE COOKIEX, COOKIEY, COOKIECEL, AUXPAGE

   '- flame secetion -
   FOR I = 1 TO MAXJSV
     IF JSVATK(I) THEN
       IF JSVATKTIMER(I) > 0 THEN JSVATKTIMER(I) = JSVATKTIMER(I) - 1
       IF JSVATKTIMER(I) < 10 THEN         '- FLAME START -
         JSVFLAMEPTN(I) = JSVFLAMEPTN(I) + 1
         UPDATEFLAME JSVFLAMEX(I), JSVFLAMEY(I), JSVFLAMEPTN(I) + JSVFLAMEDIR(I) * 10, AUXPAGE
       END IF

       '- wow ! hit detection(flame) -
       IF (NOT HIT) AND (JSVATKTIMER(I) = 3 OR JSVATKTIMER(I) = 5 OR JSVATKTIMER(I) = 7) THEN     'when.. end of flame,
         IF (COOKIEX + 20 >= JSVFLAMEX(I)) AND (COOKIEX + 8 <= JSVFLAMEX(I) + 19) AND (COOKIEY + 18 >= JSVFLAMEY(I)) AND (COOKIEY + 1 <= JSVFLAMEY(I) + 12) AND (NOT GAMEDATA.MUTEKI) THEN
           HIT = TRUE
           CONTROL = FALSE
           COOKIEACTION = 8              'CRY
           COOKIEACTIONNUM = 5 + COOKIEDIR * 8
           COOKIECELCOUNTER = 0
           COOKIEMAXCELNUM = COOKIEPTN(COOKIEACTIONNUM, 0)

           '- sun init -
           IF NOT SUN THEN
             SUN = TRUE
             SUNCOUNTER = -1
             SUNX = COOKIEX + 7
             SUNY = (COOKIEY + 5) * 0 + JSVFLAMEY(I)
           END IF
         END IF
       END IF
       IF JSVATKTIMER(I) <= 0 THEN
         JSVATK(I) = FALSE
       END IF
     END IF
   NEXT

   IF (COOKIEACTION = 6) OR (COOKIEACTION = 7) THEN
     DRAWPLATE ELEVX, ELEVY, 1, AUXPAGE
   END IF

   IF OUCH THEN
     OUCHTIMER = OUCHTIMER - 1
     IF OUCHTIMER < 0 THEN OUCH = FALSE
     UPDATEOUCH OUCHX, OUCHY, AUXPAGE
   END IF

   IF SUN THEN
     SUNCOUNTER = SUNCOUNTER + 1
     IF SUNCOUNTER >= 3 THEN SUN = FALSE
     UPDATESUN SUNX, SUNY, SUNCOUNTER, AUXPAGE
   END IF

   IF GAMEDATA.DEBUG THEN
     '- output free memory -
     SCREEN , , AUXPAGE, VISPAGE
     LOCATE 1, 2
     PRINT USING "FREE ARRAY=###### / STACK=####"; FRE(-1); FRE(-2)
   END IF
   
   '- view output -
   OUTPUTAUXPAGE
   DELAY 1

 LOOP UNTIL (RESULT > 0)

 GLOW 0

END SUB

SUB GLOW (N)

 C = VAL(MID$("00071523313947556355473931231507", N * 2 + 1, 2))
 OUT &H3C8, 21
 OUT &H3C9, C
 OUT &H3C9, C
 OUT &H3C9, C

END SUB

SUB INITGRAPHIC

 SCREEN 7, , VISPAGE, VISPAGE
 CLS

 '- set color -
 PRINT "SET NEW COLOR"
 NEWCOLOR

 '- load graphics -
 PRINT "LOAD GRAPHIC(s)"
 LOADSCREEN "PAGE1", 1
 LOADSCREEN "PAGE2", 2
 LOADSCREEN "PAGE3", 3
 LOADSCREEN "TITLE", TITLEPAGE
 LOADSCREEN "DEMO", DEMOPAGE
 LOADSCREEN "LOGO", LOGOPAGE

END SUB

SUB INITMAINVARIABLE

 PLAY "MB"

 RANDOMIZE TIMER

 JOY.STICKFOUND = FALSE
 JOY.CALIBRATED = FALSE

 GAMEDATA.BEAT = FALSE
 GAMEDATA.DEBUG = FALSE

 '-< load font data >-
 PRINT "SET NEW FONT"
 OPEN DRIVE$ + DATAPATH$ + "NEWFONT.FNT" FOR INPUT AS #1
 FOR I = 32 TO 126
   LINE INPUT #1, NEWFONT$(I)
 NEXT
 CLOSE #1

 '-< load object pattern >-
 OPEN DRIVE$ + DATAPATH$ + "JSVPTN.PTN" FOR INPUT AS #1
 PRINT "LOAD CHARACTER PATTERN"
 FOR J = 0 TO 69
   FOR I = 0 TO 20
     INPUT #1, JSVPTN(J, I)
   NEXT
 NEXT
 CLOSE #1

 '-< load main character pattern >-
 OPEN DRIVE$ + DATAPATH$ + "COOKIE.PTN" FOR INPUT AS #1
 PRINT "LOAD OBJECT PATTERN"
 FOR J = 0 TO 21
   FOR I = 0 TO 25
     INPUT #1, COOKIEPTN(J, I)
   NEXT
 NEXT
 CLOSE #1

 '-< load demo (animation) pattern >-
 PRINT "LOAD DEMO (ANIMATION) PATTERN"
 OPEN DRIVE$ + DATAPATH$ + "DEMO1PTN.PTN" FOR INPUT AS #1
 FOR I = 0 TO 22
   INPUT #1, DEMO1PTN(I)
 NEXT
 CLOSE #1

 OPEN DRIVE$ + DATAPATH$ + "DEMO2PTN.PTN" FOR INPUT AS #1
 FOR I = 0 TO 20
   INPUT #1, DEMO2PTN(I)
 NEXT
 CLOSE #1

 OPEN DRIVE$ + DATAPATH$ + "DEMO3PTN.PTN" FOR INPUT AS #1
 FOR I = 0 TO 5
   INPUT #1, DEMO3PTN(I)
 NEXT
 CLOSE #1

 OPEN DRIVE$ + DATAPATH$ + "DEMO4PTN.PTN" FOR INPUT AS #1
 FOR I = 0 TO 123
   INPUT #1, DEMO4PTN(I)
 NEXT
 CLOSE #1

 DELAY 1

 '-< initialize (check) stick >-
 INITSTICK
 JOY.STICKON = JOY.STICKFOUND

 FADE COLOR2BLACK
 CLS

END SUB

SUB INITSTICK

 '- initialize -
 COUNTER = 0
 OUT &H201, 0

 '- main -
 DO
   STICKDATA = INP(&H201)
   COUNTER = COUNTER + (1 AND STICKDATA)
 LOOP WHILE (COUNTER < 32767) AND (STICKDATA AND 1)

 JOY.STICKFOUND = (COUNTER <> 32767)

END SUB

FUNCTION JOYPAD

 '- initialize -
 ANGLE = 0

 '- main -
 IF JOY.STICKFOUND AND JOY.CALIBRATED THEN
   STICKY = 0: STICKX = 0: DUMMY = 0

   '- calculate stick value -
   OUT &H201, 0
   DO
     STICKDATA = INP(&H201)
     IF STICKDATA AND 1 THEN STICKX = STICKX + 1 ELSE DUMMY = DUMMY + 1
     IF STICKDATA AND 2 THEN STICKY = STICKY + 1 ELSE DUMMY = DUMMY + 1
   LOOP UNTIL ((STICKDATA AND &H1) OR (STICKDATA AND &H2)) = 0

   '- calculate direction -
   ANGLE = 0

   IF STICKY <= JOY.STICKMINY THEN ANGLE = 1
   IF STICKX >= JOY.STICKMAXX THEN ANGLE = 3
   IF STICKY >= JOY.STICKMAXY THEN ANGLE = 5
   IF STICKX <= JOY.STICKMINX THEN ANGLE = 7
   IF STICKY <= JOY.STICKMINY AND STICKX >= JOY.STICKMAXX THEN ANGLE = 2
   IF STICKX >= JOY.STICKMAXX AND STICKY >= JOY.STICKMAXY THEN ANGLE = 4
   IF STICKX <= JOY.STICKMINX AND STICKY >= JOY.STICKMAXY THEN ANGLE = 6
   IF STICKY <= JOY.STICKMINX AND STICKX <= JOY.STICKMINX THEN ANGLE = 8
 END IF

 JOYPAD = ANGLE

END FUNCTION

SUB LOADLEVEL (P, SCORE&, HISCORE&, JSVSCORE&, JSVNUM&, MAXOBJ)

 P$ = STRING$(30, "0") + "A1" + STRING$(8, "0")
 MAXOBJ = 0
 IF P >= 1 AND P <= 10 THEN
   OPEN DRIVE$ + LEVELNAME$ FOR RANDOM AS #1 LEN = 40
   FIELD #1, 40 AS LVLDATA$
   GET #1, P
   P$ = LVLDATA$
   CLOSE #1

   '- fill level array -
   FOR J = 0 TO 3
     FOR I = 0 TO 9
       OBJECT = VAL("&H" + MID$(P$, J * 10 + I + 1, 1))
       LEVELARRAY(I * 4 + 1, J) = OBJECT
       LISTDATA(I, J) = 0
       IF ((OBJECT > 0) AND (OBJECT < 8)) THEN
         MAXOBJ = MAXOBJ + 1
         LISTDATA(I, J) = MAXOBJ
       END IF
     NEXT
   NEXT

   DRAWBACKGROUND SCORE&, HISCORE&, JSVSCORE&, JSVNUM&

   '- update object -
   FOR J = 0 TO 3
     FOR I = 0 TO 9
       MAPDATA(I, J) = 0
       LINKDATA(I, J) = 0
       OBJECT = LEVELARRAY(I * 4 + 1, J)
       SELECT CASE OBJECT
       CASE 1 TO 7
         UPDATEOBJECT I * 32 + 6, J * 45 + 21, JSVPTN((OBJECT - 1) * 10, 1), BACKGROUNDPAGE
         MAPDATA(I, J) = 1
         
       CASE 8 TO 9
         SCREEN , , 1, VISPAGE
         GET (271, 1 + (OBJECT - 8) * 9)-(299, 8 + (OBJECT - 8) * 9), FMVDATA
         SCREEN , , BACKGROUNDPAGE, VISPAGE
         PUT (I * 32 + 1, J * 45 + 57), FMVDATA, PSET
       END SELECT
     NEXT
   NEXT
 END IF

END SUB

SUB LOADSCR (S$, P)

 TEMP$ = LEFT$(S$, 8)
 DEF SEG = &HB800 + &H204 * (P MOD 8)
 BLOAD GRAPHICPATH$ + TEMP$ + ".NNV", 0
 DEF SEG

END SUB

SUB LOADSCREEN (S$, P)
'---------------------------------------------------------------------------'
' S$ = FILENAME (6letters, 2identifier, and 'JSV'extension)                 '
' P  = PAGE (0 - 7)                                                         '
'---------------------------------------------------------------------------'

 TEMP$ = LEFT$(S$, 6)                     'filename : 6letter + 2code

 DEF SEG = &HA000 + (&H200 * (P MOD 8))   'select page

 OUT &H3C4, &H2                           'Sequencer register
                                          '(The color plane write
                                          'enable register)
 FOR I = 0 TO 3
   OUT &H3C5, 2 ^ I                       'select plane I for writing
   BLOAD GRAPHICPATH$ + TEMP$ + "-" + LTRIM$(STR$(I)) + ".JSV", 0
 NEXT

 OUT &H3C5, &HF                           'set all plane for other functions

 DEF SEG

END SUB

SUB LOGO

 '- logo initialize -
 LOGOCOUNTER = 0
 I1 = 80
 I2 = 2

 '- output logo -
 PCOPY LOGOPAGE, VISPAGE
 FADE BLACK2COLOR

 '- logo FX -
 DO
   I1 = I1 + 8: IF I1 >= 236 THEN I1 = 80
   I2 = I2 + 8: IF I2 >= 236 THEN I2 = 80
   PCOPY LOGOPAGE, AUXPAGE
   SCREEN , , AUXPAGE, VISPAGE
   GET (I1, 59)-(I1 + 20, 142), FMVDATA
   PUT (I1 - 1, 59), FMVDATA, PSET
   GET (I2, 59)-(I2 + 20, 142), FMVDATA
   PUT (I2 + 1, 59), FMVDATA, PSET
   SCREEN , , VISPAGE, VISPAGE
   PCOPY AUXPAGE, VISPAGE
   LOGOCOUNTER = LOGOCOUNTER + 1
   DELAY 1
 LOOP UNTIL INKEY$ <> "" OR BUTTON(1) OR LOGOCOUNTER >= 80

 PCOPY LOGOPAGE, VISPAGE
 SCREEN , , VISPAGE, VISPAGE

 FADE COLOR2BLACK
 CLS

END SUB

SUB MAIN (HISCORE&)

 SCORE& = 0
 JSVSCORE& = 0

 LEVEL = 0
 GAMERESULT = 1
 DEMO 1, JSVSCORE&
 DO
   IF GAMERESULT = 1 THEN LEVEL = LEVEL + 1
   JSVNUM& = 0

   FADE COLOR2BLACK
   SCREEN , , VISPAGE, VISPAGE
   CLS
   OUTPUTLEVEL (LEVEL)

   LOADLEVEL LEVEL, SCORE&, HISCORE&, JSVSCORE&, JSVNUM&, MAXOBJ
   PCOPY BACKGROUNDPAGE, AUXPAGE
   OUTPUTAUXPAGE
   FADE BLACK2COLOR

   GAME GAMERESULT, SCORE&, HISCORE&, JSVSCORE&, JSVNUM&, MAXOBJ
   '- go to next stage -
   IF GAMERESULT = 1 THEN
     SUBDEMO 1
     '- add jsv(ghost) point -
     IF JSVNUM& > 0 THEN
       DELAY 10
       FOR I& = 1 TO JSVNUM&
         JSVSCORE& = JSVSCORE& + 1 + (JSVSCORE& = 999)
         UPDATESCORE JSVSCORE&, 2, VISPAGE
         JSVNUM& = JSVNUM& - 1
         UPDATESCORE JSVNUM&, 3, VISPAGE
         DELAY 3
       NEXT
       DELAY 7
     END IF
   END IF

 '- loop until quit or clear all levels -
 LOOP UNTIL (GAMERESULT = 3 OR (LEVEL >= 10 AND GAMERESULT = 1))

 '- restore menu -
 FADE COLOR2BLACK
 MENU (-2)
 FADE BLACK2COLOR

 '- end demo -
 IF (LEVEL >= 10 AND GAMERESULT = 1) THEN
   DEMO 2, JSVSCORE&
   GAMEDATA.BEAT = TRUE
 END IF

END SUB

SUB MENU (N)

 SCREEN , , VISPAGE, VISPAGE
 IF N <= 0 THEN
   '- output default menu -
   IF N <= -1 THEN
     '- output cookie -
     IF N = -2 THEN
       PCOPY TITLEPAGE, VISPAGE
       '- (c) -
       LINE (214, 195)-(319, 199), 0, BF
     END IF

     '- title box -
     LINE (178, 46)-(283, 110), 15, BF
     LINE (179, 47)-(282, 109), 1, B
     '- mid line -
     LINE (178, 111)-(283, 111), 0
     '- menu box -
     LINE (178, 112)-(283, 186), 15, BF
     LINE (179, 113)-(282, 185), 1, B
     '- title -
     SCREEN , , 3, VISPAGE
     GET (1, 110)-(102, 170), FMVDATA
     SCREEN , , VISPAGE, VISPAGE
     PUT (180, 48), FMVDATA, PSET
   END IF
 END IF

 '- start -
 SCREEN , , 3, VISPAGE
 IF N = 1 THEN
   GET (177, 38)-(238, 45), FMVDATA
 ELSE
   GET (240, 38)-(301, 45), FMVDATA
 END IF
 SCREEN , , VISPAGE, VISPAGE
 PUT (200, 123), FMVDATA, PSET

 '- stick/keyboard -
 SCREEN , , 3, VISPAGE
 IF N = 2 THEN
   IF JOY.STICKON THEN
     GET (177, 56)-(238, 63), FMVDATA
   ELSE
     GET (240, 56)-(301, 63), FMVDATA
   END IF
 ELSE
   IF JOY.STICKON THEN
     GET (177, 92)-(238, 99), FMVDATA
   ELSE
     GET (240, 92)-(301, 99), FMVDATA
   END IF
 END IF
 SCREEN , , VISPAGE, VISPAGE
 PUT (200, 133), FMVDATA, PSET

 '- calibrate stick -
 SCREEN , , 3, VISPAGE
 IF N = 3 THEN
   IF JOY.STICKON THEN
     GET (177, 65)-(238, 72), FMVDATA
   ELSE
     GET (240, 65)-(301, 72), FMVDATA
   END IF
 ELSE
   IF JOY.STICKON THEN
     GET (177, 101)-(238, 108), FMVDATA
   ELSE
     GET (240, 65)-(301, 72), FMVDATA
   END IF
 END IF
 SCREEN , , VISPAGE, VISPAGE
 PUT (200, 143), FMVDATA, PSET

 '- exit -
 SCREEN , , 3, VISPAGE
 IF N = 4 THEN
   GET (177, 74)-(238, 81), FMVDATA
 ELSE
   GET (240, 74)-(301, 81), FMVDATA
 END IF
 SCREEN , , VISPAGE, VISPAGE
 PUT (200, 153), FMVDATA, PSET

 '- ??????(secret) -
 SCREEN , , 3, VISPAGE
 IF N = 6 THEN
   IF GAMEDATA.BEAT THEN
     GET (177, 83)-(238, 90), FMVDATA
   ELSE
     GET (240, 101)-(301, 108), FMVDATA
   END IF
 ELSE
   IF GAMEDATA.BEAT THEN
     GET (240, 83)-(301, 90), FMVDATA
   ELSE
     GET (240, 101)-(301, 108), FMVDATA
   END IF
 END IF
 SCREEN , , VISPAGE, VISPAGE
 PUT (200, 173), FMVDATA, PSET

END SUB

SUB NEWCOLOR

 '- set NEW color -
 OUT &H3C8, 0
 FOR I = 0 TO 3
   '- original color -
   'OUT &H3C9, VAL(MID$("250009270918451800000000000000006363545509544563", I * 2 + 1, 2))
   'OUT &H3C9, VAL(MID$("260054630927095400000000000000000921545436184563", I * 2 + 1, 2))
   'OUT &H3C9, VAL(MID$("270009276363096300000000000000000921093609454563", I * 2 + 1, 2))

   '- modified color -
   OUT &H3C9, VAL(MID$("250009270918451800000000000000006363545509004563", I * 2 + 1, 2))
   OUT &H3C9, VAL(MID$("260054630927095400000000000000000921545436004563", I * 2 + 1, 2))
   OUT &H3C9, VAL(MID$("270009276363096300000000000000000921093609004563", I * 2 + 1, 2))
 NEXT

END SUB

FUNCTION NUM2STR$ (N&, L)

 IF N& < 0 THEN
   NUM2STR$ = RIGHT$(STRING$(L, 45), L)
 ELSE
   NUM2STR$ = RIGHT$(STRING$(L, 48) + LTRIM$(STR$(N&)), L)
 END IF

END FUNCTION

SUB OUTPUTAUXPAGE

 SCREEN , , VISPAGE, VISPAGE
 PCOPY AUXPAGE, VISPAGE

END SUB

SUB OUTPUTBIGNUMBER (X, Y, N)

 IF INSTR("02356789", LTRIM$(STR$(N))) THEN
   DRAW "BM" + STR$(X + 4) + "," + STR$(Y + 0)
   DRAW "C4 R3DER4DER2D3L3UGL4UGL2U2 C15 BR DRUBR2NR3DR3BR2RUL"
 END IF

 IF INSTR("045689", LTRIM$(STR$(N))) THEN
   DRAW "BM" + STR$(X + 4) + "," + STR$(Y + 0)
   DRAW "C4 R3D3L2FD3GD3L3U3R2HU3EU2 C15 BRRDLBD2ND3LD3BD2DLU"
 END IF

 IF INSTR("01234789", LTRIM$(STR$(N))) THEN
   DRAW "BM" + STR$(X + 12) + "," + STR$(Y + 0)
   DRAW "C4 R3D3L2FD3GD3L3U3R2HU3EU2 C15 BRRDLBD2ND3LD3BD2DLU"
 END IF

 IF INSTR("2345689", LTRIM$(STR$(N))) THEN
   DRAW "BM" + STR$(X + 2) + "," + STR$(Y + 8)
   DRAW "C 4 R3DER4DER2D3L3UGL4UGL2U2 C15 BR DRUBR2NR3DR3BR2RUL"
 END IF

 IF INSTR("0268", LTRIM$(STR$(N))) THEN
   DRAW "BM" + STR$(X + 2) + "," + STR$(Y + 8)
   DRAW "C4 R3D3L2FD3GD3L3U3R2HU3EU2 C15 BRRDLBD2ND3LD3BD2DLU"
 END IF

 IF INSTR("013456789", LTRIM$(STR$(N))) THEN
   DRAW "BM" + STR$(X + 10) + "," + STR$(Y + 8)
   DRAW "C4 R3D3L2FD3GD3L3U3R2HU3EU2 C15 BRRDLBD2ND3LD3BD2DLU"
 END IF

 IF INSTR("0235689", LTRIM$(STR$(N))) THEN
   DRAW "BM" + STR$(X + 0) + "," + STR$(Y + 16)
   DRAW "C 4 R3DER4DER2D3L3UGL4UGL2U2 C15 BR DRUBR2NR3DR3BR2RUL"
 END IF

END SUB

SUB OUTPUTLEVEL (N)

 FADE BLACK2COLOR

 '- draw 'LEVEL nn' -
 SCREEN , , BACKGROUNDPAGE, VISPAGE
 CLS
 DRAW "BM99,90"
 '- L -
 DRAW "C4 BR4R3D3L2FD3GD3L2FD3GDER4DER2D3L2HDL4HDL3U3R2HU3EU3R2HU3EU2"
 DRAW "C15 BRRDLBD2ND3LD3BD2DHDBD2ND3LD3BD2LDRBR2NR3UR3BR2RDL BM+6,-18"
 '- E -
 DRAW "C4 BR4R3DER4DER2D3L3UGL4UGLFD3GDER4DER2D3L3UG"
 DRAW "L4UGLFD3GDER4DER2D3L3UGL4UGL2U3R2HU3EU3R2HU3EU2"
 DRAW "C15 BRRBR2R3BR2RDLBL2L3BL2LBD2ND3LD3BF2R3BR2RDL"
 DRAW "BL2L3BL2ULDBD2ND3LD3BD2LDRBR2NR3UR3BR2RDL BM+6,-18"
 '- V -
 DRAW "C4 BR4R3D3LFD4LFDGR3HEURU2EUEU3R3D3L2FDG"
 DRAW "DGLFGDLD2GDGDHNU4LFD2L3U3RHU4RHU2RHU4RHU"
 DRAW "C15 BRDEDBD2ND3LD3BD2DEDBD2ND3LD3BD2"
 DRAW "RDLBE3U3FUBU2RURBU2UFU3FUBU2URNDBE"
 '- E -
 DRAW "C4 BR4R3DER4DER2D3L3UGL4UGLFD3GDER4DER2D3L3UG"
 DRAW "L4UGLFD3GDER4DER2D3L3UGL4UGL2U3R2HU3EU3R2HU3EU2"
 DRAW "C15 BRRBR2R3BR2RDLBL2L3BL2LBD2ND3LD3BF2R3BR2RDL"
 DRAW "BL2L3BL2ULDBD2ND3LD3BD2LDRBR2NR3UR3BR2RDL BM+6,-18"
 '- L -
 DRAW "C4 BR4R3D3L2FD3GD3L2FD3GDER4DER2D3L2HDL4HDL3U3R2HU3EU3R2HU3EU2"
 DRAW "C15 BRRDLBD2ND3LD3BD2DHDBD2ND3LD3BD2LDRBR2NR3UR3BR2RDL BM+6,-18"
 '- 00 -
 OUTPUTBIGNUMBER 189, 90, (N \ 10)
 OUTPUTBIGNUMBER 204, 90, (N MOD 10)
 SCREEN , , VISPAGE, VISPAGE
 CLS

 '- get FX -
 SCREEN , , 3, 0
 GET (1, 172)-(46, 191), FMVDATA

 '- appear -
 FOR I = 0 TO 168 STEP 3
   SCREEN , , AUXPAGE, VISPAGE
   PCOPY BACKGROUNDPAGE, AUXPAGE
   PUT (53 + I, 90), FMVDATA, AND
   LINE (99 + I, 90)-(267, 109), 0, BF
   SCREEN , , VISPAGE, VISPAGE
   PCOPY AUXPAGE, VISPAGE
   DELAY 1
 NEXT
 DELAY 20

 '- get FX -
 SCREEN , , 3, 0
 GET (48, 172)-(93, 191), FMVDATA

 '- disappear -
 FOR I = 0 TO 168 STEP 3
   SCREEN , , AUXPAGE, VISPAGE
   PCOPY BACKGROUNDPAGE, AUXPAGE
   PUT (53 + I, 90), FMVDATA, AND
   LINE (53 + I, 90)-(53, 109), 0, BF
   SCREEN , , VISPAGE, VISPAGE
   PCOPY AUXPAGE, VISPAGE
   DELAY 1
 NEXT
 DELAY 20
 FADE COLOR2BLACK

END SUB

SUB SCROLLTEXT

 FOR I = 1 TO 3
   GET (186, 51)-(275, 68), FMVMASK
   PUT (186, 50), FMVMASK, PSET
   GET (186, 51)-(275, 68), FMVMASK
   PUT (186, 50), FMVMASK, PSET
   GET (186, 51)-(275, 68), FMVMASK
   PUT (186, 50), FMVMASK, PSET
   DELAY 1
 NEXT

END SUB

SUB SUBDEMO (P)
 SELECT CASE P

 CASE IS = 0
   DELAY 2
   UPDATEDOOR 0, BACKGROUNDPAGE
   PCOPY BACKGROUNDPAGE, AUXPAGE

   FOR I = 0 TO 3
     UPDATEDOOR VAL(MID$("0654", I + 1, 1)), AUXPAGE
     OUTPUTAUXPAGE
     DELAY 2
   NEXT
   DELAY 2

   PCOPY BACKGROUNDPAGE, AUXPAGE
   UPDATEDOOR 3, AUXPAGE
   UPDATECOOKIE 1, 172, 6, AUXPAGE
   DELAY 2
   OUTPUTAUXPAGE
   DELAY 2

   FOR I = 3 TO 0 STEP -1
     UPDATEDOOR I, AUXPAGE
     UPDATECOOKIE 1, 172, 6, AUXPAGE
     OUTPUTAUXPAGE
     DELAY 2
   NEXT

   FOR I = 1 TO COOKIEPTN(17, 0)
     PCOPY BACKGROUNDPAGE, AUXPAGE
     UPDATECOOKIE 1, 172, COOKIEPTN(17, I), AUXPAGE
     OUTPUTAUXPAGE
     DELAY 2
   NEXT

 CASE IS = 1
   UPDATEDOOR 3, BACKGROUNDPAGE
   FOR I = 1 TO COOKIEPTN(19, 0)
     PCOPY BACKGROUNDPAGE, AUXPAGE
     UPDATECOOKIE 1, 172, COOKIEPTN(19, I), AUXPAGE
     OUTPUTAUXPAGE
     DELAY 2
   NEXT
   DELAY 2

   PCOPY BACKGROUNDPAGE, AUXPAGE
   UPDATEDOOR 3, AUXPAGE
   UPDATECOOKIE 1, 171, 2, AUXPAGE
   DELAY 2
   OUTPUTAUXPAGE
   DELAY 2

   FOR I = 1 TO COOKIEPTN(20, 0)
     PCOPY BACKGROUNDPAGE, AUXPAGE
     UPDATECOOKIE 1, 171, COOKIEPTN(20, I), AUXPAGE
     SCREEN , , AUXPAGE, VISPAGE
     DRAW "BM25,180 C1D10BR C14U10BR"
     OUTPUTAUXPAGE
     DELAY 2
   NEXT
   DELAY 2

   FOR I = 0 TO 3
     UPDATEDOOR VAL(MID$("4560", I + 1, 1)), AUXPAGE
     OUTPUTAUXPAGE
     DELAY 2
   NEXT
 END SELECT

END SUB

SUB SUBMENU (N, RESULT)

 GLOW 0

 UPDATESUBMENU N, -1

 CHOICE = N
 SELECTED = FALSE
 CANCELED = FALSE

 UPDATESUBMENU N, CHOICE
 DO
   '- get key board -
   A$ = INKEY$: DUMMY = RND(1)
   IF LEN(A$) = 2 THEN A$ = "*" + RIGHT$(A$, 1)
   IF A$ = CHR$(27) THEN CANCELED = TRUE

   '- get stick & button(s) -
   ST = JOYPAD
   IF ST = 0 THEN STICKRELEASED = TRUE

   TR = BUTTON(1) OR BUTTON(2)
   IF NOT TR THEN BUTTONRELEASED = TRUE

   '- check stick & button(s) -
   IF JOY.STICKON AND STICKRELEASED THEN
     IF ST = 6 OR ST = 7 OR ST = 8 THEN A$ = "*K"
     IF ST = 2 OR ST = 3 OR ST = 4 THEN A$ = "*M"
     IF ST THEN STICKRELEASED = FALSE
   END IF

   IF TR AND BUTTONRELEASED THEN
     BUTTONRELEASED = FALSE
     A$ = " "
   END IF

   '- menu selection -
   IF A$ = "*K" THEN CHOICE = 0
   IF A$ = "*M" THEN CHOICE = 1
   IF A$ = " " OR A$ = CHR$(13) THEN SELECTED = TRUE

   UPDATESUBMENU N, CHOICE

   DELAY 1

 LOOP UNTIL SELECTED OR CANCELED
 RESULT = (CHOICE = 0) AND (SELECTED)

END SUB

SUB TALK (MSG$, MOUTH$, LINENUM)

 MSGLEN = LEN(MSG$)
 IF MSGLEN THEN
   FOR I = 1 TO MSGLEN
     '- output mouth -
     UPDATEMOUTH VAL(MID$(MOUTH$, I, 1)), 0
     DELAY 1

     '- calculate message -
     MSGX = ((I - 1) * 7) + 192 - 4
     MSGY = (LINENUM * 11) + 29
     LETTER$ = MID$(MSG$, I, 1)

     '- output text -
     DRAWNEWFONT (MSGX + 0), (MSGY + 1), &HC, 0, 0, LETTER$
     DRAWNEWFONT (MSGX + 0), (MSGY + 0), &HC, 0, 0, LETTER$
     DRAWNEWFONT (MSGX + 1), (MSGY + 1), &HC, 0, 0, LETTER$
     DRAWNEWFONT (MSGX + 1), (MSGY + 0), &H3, 0, 0, LETTER$
     DELAY 1
   NEXT
 END IF

END SUB

SUB TITLE

 '- initialize -
 HISCORE& = 2000

 SELECTION = 1 - ((JOY.STICKFOUND AND JOY.STICKON) * 2)

 CURSORX = 0
 CURSORY = (SELECTION - 1) * 10

 CURSORDIR = 0
 CURSORMOVE = 0
 CURSORPTN = 0

 BLINKCOUNTER = 0
 QUIT = FALSE

 '- redraw menu -
 MENU (-2)
 UPDATECURSOR CURSORX, CURSORY, CURSORPTN
 FADE BLACK2COLOR

 '- main -
 DO
   SELECTED = FALSE
   DO
     '- get key board -
     A$ = INKEY$: DUMMY = RND(1)
     IF LEN(A$) = 2 THEN A$ = "*" + RIGHT$(A$, 1)
     IF A$ = CHR$(13) THEN A$ = " "

     '- emergency stick-OFF -
     IF A$ = CHR$(27) THEN
       JOY.CALIBRATED = FALSE
       JOY.STICKON = FALSE
     END IF

     '- get stick & button(s) -
     ST = JOYPAD
     IF ST = 0 THEN STICKRELEASED = TRUE

     TR = BUTTON(1) OR BUTTON(2)
     IF NOT TR THEN BUTTONRELEASED = TRUE

     IF JOY.STICKON AND STICKRELEASED THEN
       IF ST = 8 OR ST = 1 OR ST = 2 THEN A$ = "*H"
       IF ST = 4 OR ST = 5 OR ST = 6 THEN A$ = "*P"
       IF ST THEN STICKRELEASED = FALSE
     END IF

     IF TR AND BUTTONRELEASED THEN
       BUTTONRELEASED = FALSE
       A$ = " "
     END IF

     '- calculate cursor -
     IF CURSORMOVE > 0 THEN
       CURSORMOVE = CURSORMOVE - 1
       CURSORY = CURSORY + CURSORDIR
       IF CURSORMOVE = 0 THEN
         CURSORPTN = 0
         SELECTION = CURSORY \ 10 + 1
       END IF
     END IF

     '- check key -
     IF CURSORMOVE <= 0 THEN
       IF A$ = " " THEN SELECTED = TRUE

       IF A$ = "*P" AND CURSORY < 30 - (10 * GAMEDATA.BEAT) THEN
         SELECTION = 0
         CURSORDIR = 2
         IF (CURSORY = 10 AND NOT JOY.STICKON) OR (CURSORY = 30) THEN
           CURSORMOVE = 10
         ELSE
           CURSORMOVE = 5
         END IF
         CURSORPTN = 1
       END IF
       IF A$ = "*H" AND CURSORY > 0 THEN
         SELECTION = 0
         CURSORDIR = -2
         IF (CURSORY = 30 AND NOT JOY.STICKON) OR (CURSORY = 50) THEN
           CURSORMOVE = 10
         ELSE
           CURSORMOVE = 5
         END IF
         CURSORPTN = 1
       END IF
     END IF
   
     IF A$ = "*" + CHR$(134) THEN GAMEDATA.BEAT = NOT GAMEDATA.BEAT

     '- output -
     BLINKCOUNTER = (BLINKCOUNTER + 1) MOD 50
     UPDATEBLINK (BLINKCOUNTER), VISGAGE

     UPDATECURSOR CURSORX, CURSORY, CURSORPTN
     MENU (SELECTION)

     DELAY 1

   LOOP UNTIL SELECTED

   '- selection -
   SELECT CASE SELECTION
   CASE IS = 1:
     ADJUSTEYE (BLINKCOUNTER)
     MAIN (HISCORE&)

   CASE IS = 2
     JOY.STICKON = (NOT JOY.STICKON) AND JOY.STICKFOUND

   CASE IS = 3
     ADJUSTEYE (BLINKCOUNTER)
     CALSTICK
     BLINKCOUNTER = 0
     MENU (-1)

   CASE IS = 4
     QUIT = TRUE

   CASE IS = 6
     IF GAMEDATA.BEAT THEN
       ADJUSTEYE (BLINKCOUNTER)
       VIEWER
       MENU (-1)
     END IF
     BLINKCOUNTER = BLINKCOUNTER * -(BLINKCOUNTER < 4)
   END SELECT
 LOOP UNTIL QUIT

 '- adjust eye pattern & blink -
 ADJUSTEYE (BLINKCOUNTER)
 FOR I = 1 TO 2
   UPDATEBLINK (I), VISPAGE
   DELAY 1
 NEXT
 DELAY 5

 FADE COLOR2BLACK
 CLS
 DELAY 1

 IF GAMEDATA.BEAT THEN
   DEMO 3, JSVSCORE&
 END IF

 CLS

END SUB

SUB UPDATEBLINK (N, P)

 IF N = 3 THEN N = 1 ELSE IF N > 3 THEN N = 0
 SCREEN , , 3, VISPAGE
 GET ((N * 58) + 1, 75)-((N * 58) + 57, 99), FMVDATA
 SCREEN , , P, VISPAGE
 PUT (53, 53), FMVDATA, PSET

END SUB

SUB UPDATECOOKIE (X, Y, P, P2)

 SCREEN , , 1, VISPAGE
 GET (1 + (P MOD 9) * 30, 1 + ((P + 27) \ 9) * 21)-(29 + (P MOD 9) * 30, 20 + ((P + 27) \ 9) * 21), FMVMASK
 GET (1 + (P MOD 9) * 30, 1 + (P \ 9) * 21)-(29 + (P MOD 9) * 30, 20 + (P \ 9) * 21), FMVDATA
 SCREEN , , P2, VISPAGE
 PUT (X, Y), FMVMASK, AND
 PUT (X, Y), FMVDATA, OR

 IF GAMEDATA.DEBUG THEN LINE (X + 8, Y + 2)-(X + 20, Y + 18), 8, B

END SUB

SUB UPDATECURSOR (X, Y, N)

 '- left cursor -
 SCREEN , , 1, VISPAGE
 GET (271 + (N * 11), 83)-(280 + (N * 11), 103), FMVDATA
 SCREEN , , VISPAGE, VISPAGE
 PUT (181 + X, 114 + Y), FMVDATA, PSET

 '- right cursor -
 SCREEN , , 1, VISPAGE
 GET (271 + (N * 11), 105)-(280 + (N * 11), 125), FMVDATA
 SCREEN , , VISPAGE, VISPAGE
 PUT (271 - X, 114 + Y), FMVDATA, PSET

END SUB

SUB UPDATEDEMO (X, Y, P, P1)

 TEMPX = P MOD 9
 TEMPY = P \ 9
 SCREEN , , DEMOPAGE, VISPAGE
 GET (1 + (TEMPX * 33), 63 + (TEMPY * 33))-((TEMPX * 33) + 32, 94 + (TEMPY * 33)), FMVMASK
 SCREEN , , P1, VISPAGE
 PUT (X, Y), FMVMASK, PSET

END SUB

SUB UPDATEDOOR (N, P)

 DOORX = N MOD 4
 DOORY = N \ 4
 SCREEN , , 1, VISPAGE
 GET (DOORX * 28 + 1, DOORY * 30 + 127)-(DOORX * 28 + 27, DOORY * 30 + 155), FMVDATA
 SCREEN , , P, VISPAGE
 PUT (2, 164), FMVDATA, PSET

END SUB

SUB UPDATEEYE (N, P)

 EYEX = (N MOD 3) * 54
 EYEY = (N \ 3) * 20
 SCREEN , , 1, VISPAGE
 GET (113 + EYEX, 127 + EYEY)-(165 + EYEX, 145 + EYEY), FMVDATA
 SCREEN , , P, VISPAGE
 PUT (55, 56), FMVDATA, PSET

END SUB

SUB UPDATEFLAME (X, Y, N, P)

 FX = N \ 10
 FY = N MOD 10
 SCREEN , , TITLEPAGE, VISPAGE
 GET (179 + FX * 42, FY * 14 + 47)-(198 + FX * 42, FY * 14 + 59), FMVDATA
 GET (200 + FX * 42, FY * 14 + 47)-(219 + FX * 42, FY * 14 + 59), FMVMASK
 SCREEN , , P, VISPAGE
 PUT (X, Y), FMVMASK, AND
 PUT (X, Y), FMVDATA, OR

 IF GAMEDATA.DEBUG THEN
   IF FY = 2 OR FY = 4 OR FY = 6 THEN
     LINE (X, Y)-(X + 19, Y + 12), 8, B
   ELSE
     LINE (X, Y)-(X + 19, Y + 12), 15, B
   END IF
 END IF

END SUB

SUB UPDATEMOUTH (N, P)

 SCREEN , , 3, VISPAGE
 GET (161, N * 10 + 38)-(175, N * 10 + 46), FMVDATA
 SCREEN , , P, VISPAGE
 PUT (74, 84), FMVDATA, PSET

END SUB

SUB UPDATEOBJECT (X, Y, P, P2)

 IF P >= 0 AND P <= 97 THEN
   OBJX = P MOD 15
   OBJY = (P \ 15) MOD 5
   OBJP = (P \ 75)
   SCREEN , , 2 + OBJP, VISPAGE
   GET (1 + OBJX * 20, 1 + OBJY * 37)-(19 + OBJX * 20, 36 + OBJY * 37), FMVDATA
   SCREEN , , P2, VISPAGE
   PUT (X, Y), FMVDATA, PSET
 END IF

END SUB

SUB UPDATEOUCH (X, Y, P)

 SCREEN , , 1, VISPAGE
 GET (293, 83)-(313, 95), FMVDATA
 GET (293, 97)-(313, 109), FMVMASK
 SCREEN , , P, VISPAGE
 PUT (X, Y), FMVMASK, AND
 PUT (X, Y), FMVDATA, OR

END SUB

SUB UPDATESCORE (SC&, N, P)

 SCREEN , , P, VISPAGE
 SELECT CASE N
 CASE IS = 0
   LOCATE 1, 2: PRINT "SCORE ";
   PRINT NUM2STR$(SC&, 7);

 CASE IS = 1
   LOCATE 1, 16: PRINT "HI-SCORE ";
   PRINT NUM2STR$(SC&, 7);

 CASE IS = 2
   LOCATE 2, 35
   PRINT NUM2STR$(SC&, 3);

 CASE IS = 3
   LOCATE 2, 38: PRINT "+";
   PRINT NUM2STR$(SC&, 2);
 END SELECT

END SUB

SUB UPDATESUBMENU (P, N)

 X = 91
 Y = 66

 IF N = -1 THEN
   '- outline -
   LINE (X, Y)-(X + 137, Y + 65), 1, B
   LINE (X + 1, Y + 1)-(X + 136, Y + 50), 14, BF
   LINE (X + 1, Y + 51)-(X + 136, Y + 64), 0, BF
   LINE (X + 2, Y + 2)-(X + 135, Y + 63), 15, B

   '- cookie -
   SCREEN , , 3, VISPAGE
   GET (183, 110)-(225, 165), FMVDATA
   GET (227, 110 + (P * 21))-(308, 129 + (P * 21)), FMVMASK
   SCREEN , , VISPAGE, VISPAGE
   PUT (X + 5, Y + 5), FMVDATA, PSET
   PUT (X + 52, Y + 5), FMVMASK, PSET

   IF P = 0 THEN
     SCREEN , , 3, VISPAGE
     GET (1, 193)-(45, 197), FMVDATA
     SCREEN , , VISPAGE, VISPAGE
     PUT (X + 87, Y + 55), FMVDATA, PSET
   END IF
 ELSE
   SCREEN , , 3, VISPAGE
   GET (227 + (N * 45), 152)-(252 + (N * 45), 171), FMVDATA
   GET (254 + (1 - N) * 45, 152)-(270 + (1 - N) * 45, 171), FMVMASK
   SCREEN , , VISPAGE, VISPAGE
   PUT (X + 61, Y + 28), FMVDATA, PSET
   PUT (X + 106, Y + 28), FMVMASK, PSET
 END IF

END SUB

SUB UPDATESUN (X, Y, N, P)

 SCREEN , , 1, VISPAGE
 GET (271 + 0 * 16, 19 + N * 16)-(285 + 0 * 16, 33 + N * 16), FMVDATA
 GET (271 + 1 * 16, 19 + N * 16)-(285 + 1 * 16, 33 + N * 16), FMVMASK
 SCREEN , , P, VISPAGE
 PUT (X, Y), FMVMASK, AND
 PUT (X, Y), FMVDATA, OR

END SUB

SUB VIEWER

 '- initialize -
 FMVPTN = 0
 QUIT = FALSE
 CELPTN = 0
 ACTIONPTNCOUNTER = 1
 ACTIONDATA$ = MID$("123143678698", INT(RND(1) * 3) * 3 + 1, 3)
 ACTIONPTN = VAL(MID$(ACTIONDATA$, ACTIONPTNCOUNTER, 1))

 '- clear menu area -
 ERASEBOX

 '- draw box -
 LINE (178, 46)-(283, 186), 15, BF
 LINE (179, 47)-(282, 185), 1, B
 LINE (179, 59)-(282, 173), 1, B
 DRAWNEWFONT 192, 50, 1, 0, 0, "GHOST  VIEWER"
 DRAWNEWFONT 186, 176, 1, 0, 0, "[Esc] to  EXIT "

 '- viewer box -
 LINE (198, 78)-(263, 154), 1, B
 LINE (200, 80)-(261, 152), 1, B
 LINE (201, 81)-(260, 151), 14, BF
 LINE (201, 138)-(260, 145), 5, B
 LINE (201, 139)-(260, 144), 3, BF
 VIEWERSCROLL 0, 0, 1, 0

 '- update eye (look at the ghost... just for fun) -
 UPDATEEYE 4, VISPAGE

 DO
   '- draw arrow -
   IF FMVPTN <> 0 THEN
     DRAW "BM183,116 C 1E10D20H10BR3 P 8,1"
   ELSE
     DRAW "BM183,116 C15E10D20H10BR3 P15,1"
   END IF
   '- draw arrow -
   IF FMVPTN <> 6 THEN
     DRAW "BM278,116 C 1H10D20E10BL3 P 8,1"
   ELSE
     DRAW "BM278,116 C15H10D20E10BL3 P15,1"
   END IF
   '- get key board -
   A$ = INKEY$: DUMMY = RND(1)
   IF LEN(A$) = 2 THEN A$ = "*" + RIGHT$(A$, 1)

   '- get stick & button(s) -
   ST = JOYPAD
   IF ST = 0 THEN STICKRELEASED = TRUE

   TR = BUTTON(1) OR BUTTON(2)
   IF NOT TR THEN BUTTONRELEASED = TRUE

   '- check stick & button(s) -
   IF JOY.STICKON AND STICKRELEASED THEN
     IF ST = 6 OR ST = 7 OR ST = 8 THEN A$ = "*K"
     IF ST = 2 OR ST = 3 OR ST = 4 THEN A$ = "*M"
     IF ST THEN STICKRELEASED = FALSE
   END IF

   IF TR AND BUTTONRELEASED THEN
     BUTTONRELEASED = FALSE
     A$ = CHR$(27)
   END IF

   '- update cel pattern -
   CELPTN = CELPTN + 1

   '- calculate new object -
   IF A$ = "*K" AND FMVPTN <> 0 THEN
     FMVPTN = (FMVPTN + 6) MOD 7
     VIEWERSCROLL (FMVPTN), ACTIONPTN, CELPTN, -1
     CELPTN = 1
     ACTIONPTNCOUNTER = 1
     ACTIONDATA$ = MID$("123143678698", INT(RND(1) * 3) * 3 + 1, 3)
     ACTIONPTN = VAL(MID$(ACTIONDATA$, ACTIONPTNCOUNTER, 1))
   END IF

   IF A$ = "*M" AND FMVPTN <> 6 THEN
     FMVPTN = (FMVPTN + 1) MOD 7
     VIEWERSCROLL (FMVPTN), ACTIONPTN, CELPTN, 1
     CELPTN = 1
     ACTIONPTNCOUNTER = 1
     ACTIONDATA$ = MID$("123143678698", INT(RND(1) * 3) * 3 + 1, 3)
     ACTIONPTN = VAL(MID$(ACTIONDATA$, ACTIONPTNCOUNTER, 1))
   END IF

   IF A$ = CHR$(27) THEN QUIT = TRUE

   '- output object -
   UPDATEOBJECT 221, 102, JSVPTN((FMVPTN MOD 7) * 10 + ACTIONPTN, CELPTN), VISPAGE

   '- check object animation -
   IF CELPTN >= JSVPTN((FMVPTN MOD 7) * 10 + ACTIONPTN, 0) THEN
     CELPTN = 0
     ACTIONPTNCOUNTER = ACTIONPTNCOUNTER + 1
     IF ACTIONPTNCOUNTER >= 4 THEN
       ACTIONPTNCOUNTER = 1
       ACTIONDATA$ = MID$("123143678698", INT(RND(1) * 3) * 3 + 1, 3)
     END IF
     ACTIONPTN = VAL(MID$(ACTIONDATA$, ACTIONPTNCOUNTER, 1))
   END IF
   DELAY 1
 LOOP UNTIL QUIT
 ERASEBOX

END SUB

SUB VIEWERSCROLL (OBJP, OBJPTN, CELPTN, DIR)

 OBJP = (OBJP - DIR + 7) MOD 7

 SCREEN , , AUXPAGE, VISPAGE
 LINE (0, 0)-(148, 37), 1, B
 LINE (1, 1)-(147, 36), 14, BF

 UPDATEOBJECT 21, 1, JSVPTN(((OBJP + 6) MOD 7) * 10, 1), AUXPAGE
 UPDATEOBJECT 63, 1, JSVPTN(((OBJP + 0) MOD 7) * 10 + OBJPTN, CELPTN), AUXPAGE
 UPDATEOBJECT 105, 1, JSVPTN(((OBJP + 1) MOD 7) * 10, 1), AUXPAGE

 X = 42
 FOR I = 0 TO 6 * ABS(NOT (DIR - 1))
   X = X + 6 * SGN(DIR)
   SCREEN , , AUXPAGE, VISPAGE
   GET (1 + X, 1)-(60 + X, 36), FMVDATA
   SCREEN , , VISPAGE, VISPAGE
   PUT (201, 102), FMVDATA, PSET
   DELAY 1
 NEXT

END SUB

